Summary: X interface to the GDB, DBX and XDB debuggers
Name: ddd
Version: 2.2.3
Release: 1
Source0: ftp://ftp.ips.cs.tu-bs.de/pub/local/softech/ddd/src/ddd-2.2.3.tar.gz
Source1: ddd-2.2.3-README.linux
Patch0: ddd-2.2.3-linux-librx-optimize.patch
Patch1: ddd-2.2.3-linux-termcap-optimize.patch
Copyright: GPL
Group: Development/Debuggers
URL: http://www.cs.tu-bs.de/softech/ddd/
Packager: Alec Habig <habig@budoe.bu.edu>
Buildroot: /tmp/ddd

%description
Source package for the DDD debugger.  This package generates 3 different
RPMs for 3 different binary versions plus a common RPM with documentation.
The bin RPMs are:
  
 - ddd-dynamic    : completely dynamically linked
 - ddd-semistatic : Motif library statically linked, rest dynamically
 - ddd-static     : completely statically linked

%changelog

* Mon Feb 02 1998 Alec Habig <habig@budoe.bu.edu>

- %changelog added to specfile
- changed installed binary names from *-gnulibc1-* to *-libc5-* to avoid
  confusion.  Dunno why autoconf wants to call this gnulibc.
- chown'd all the installed stuff to bin.bin
- gzip'd the docs' ChangeLog
- librx and termcap subdirs are not getting passed the RPM compile opts via
  configure.  The changed opts exist in the config.status files, but something
  in the sed scripts is broken because they are being ignored when Makefile.in
  is turned into Makefile.  Thus, patches put back on the Makefile.in's in
  these dirs.

* Fri Jan 30 1998 Alec Habig <habig@budoe.bu.edu>

- Changes from ddd-2.2 spec file to update to 2.2.3 - mostly name changes
- Removed patches to Makefiles in exchange for suppliing the RPM build opts via
  a configure parameter.
- replace the hardwired "i586" in the programs names with a call to uname.

%package dynamic
Summary: X interface to the GDB, DBX and XDB debuggers
Group: Development/Debuggers

%description dynamic
Fully dynamically linked DDD binary that uses Motif 2.0 shared library.
The Data Display Debugger (DDD) is a common graphical user interface
for GDB, DBX, and XDB, the popular UNIX debuggers.  Besides ``classical''
front-end features such as viewing source texts, DDD provides a graphical
data display, where data structures are displayed as graphs.  A simple
mouse click dereferences pointers or views structure contents, updated
each time the program stops.  Using DDD, you can reason about your
application by viewing its data, not just by viewing it execute lines of
source code.  Other DDD features include: debugging of programs written
in C, C++, Ada, Fortran, Pascal, Modula-2, or Modula-3; machine-level
debugging; hypertext source navigation and lookup; breakpoint, backtrace,
and history editors; preferences and settings editors; program execution
in terminal emulator window; debugging on remote host; on-line manual;
interactive help on the Motif user interface; GDB/DBX/XDB command-line
interface with full editing, history, search, and completion capabilities.
DDD has been designed to compete with well-known commercial debuggers
For more info on DDD see http://www.cs.tu-bs.de/softech/ddd/

%package semistatic
Summary: X interface to the GDB, DBX and XDB debuggers
Group: Development/Debuggers

%description semistatic
Dynamically linked DDD binary with Motif 2.0 library statically linked in.
The Data Display Debugger (DDD) is a common graphical user interface
for GDB, DBX, and XDB, the popular UNIX debuggers.  Besides ``classical''
front-end features such as viewing source texts, DDD provides a graphical
data display, where data structures are displayed as graphs.  A simple
mouse click dereferences pointers or views structure contents, updated
each time the program stops.  Using DDD, you can reason about your
application by viewing its data, not just by viewing it execute lines of
source code.  Other DDD features include: debugging of programs written
in C, C++, Ada, Fortran, Pascal, Modula-2, or Modula-3; machine-level
debugging; hypertext source navigation and lookup; breakpoint, backtrace,
and history editors; preferences and settings editors; program execution
in terminal emulator window; debugging on remote host; on-line manual;
interactive help on the Motif user interface; GDB/DBX/XDB command-line
interface with full editing, history, search, and completion capabilities.
DDD has been designed to compete with well-known commercial debuggers
For more info on DDD see http://www.cs.tu-bs.de/softech/ddd/


%package static
Summary: X interface to the GDB, DBX and XDB debuggers
Group: Development/Debuggers

%description static
Completely statically linked DDD binary.
The Data Display Debugger (DDD) is a common graphical user interface
for GDB, DBX, and XDB, the popular UNIX debuggers.  Besides ``classical''
front-end features such as viewing source texts, DDD provides a graphical
data display, where data structures are displayed as graphs.  A simple
mouse click dereferences pointers or views structure contents, updated
each time the program stops.  Using DDD, you can reason about your
application by viewing its data, not just by viewing it execute lines of
source code.  Other DDD features include: debugging of programs written
in C, C++, Ada, Fortran, Pascal, Modula-2, or Modula-3; machine-level
debugging; hypertext source navigation and lookup; breakpoint, backtrace,
and history editors; preferences and settings editors; program execution
in terminal emulator window; debugging on remote host; on-line manual;
interactive help on the Motif user interface; GDB/DBX/XDB command-line
interface with full editing, history, search, and completion capabilities.
DDD has been designed to compete with well-known commercial debuggers
For more info on DDD see http://www.cs.tu-bs.de/softech/ddd/


%package doc
Summary: DDD documentation
Group: Development/Debuggers

%description doc
This package contains various DDD documentation and a manual page.



%prep
%setup -T -b 0
#%setup -T -D -b 1

rm -rf		$RPM_BUILD_ROOT
mkdir -p	$RPM_BUILD_ROOT/usr/bin
mkdir -p	$RPM_BUILD_ROOT/usr/man/man1
mkdir -p	$RPM_BUILD_ROOT/usr/doc/ddd-2.2.3

%patch0 -p1
%patch1 -p1


%build
env CFLAGS="$RPM_OPT_FLAGS" CXXFLAGS="$RPM_OPT_FLAGS" ./configure -v --prefix=/usr

MACHINE=`uname -m`

# The "dynamic" version ##################################################
make RPM_OPT_FLAGS="$RPM_OPT_FLAGS"
mv ddd/ddd-2.2.3-${MACHINE}-pc-linux-gnulibc1 ddd/ddd-2.2.3-${MACHINE}-pc-linux-libc5-dynamic
#
#
# The "semistatic" version ###############################################
#
make RPM_OPT_FLAGS="$RPM_OPT_FLAGS" LIBXM="-Wl,-Bstatic -lXm -Wl,-Bdynamic"
mv ddd/ddd-2.2.3-${MACHINE}-pc-linux-gnulibc1 ddd/ddd-2.2.3-${MACHINE}-pc-linux-libc5-semistatic
#
#
# The "static" version ###################################################
#
make RPM_OPT_FLAGS="$RPM_OPT_FLAGS" LDFLAGS="-g -O -Wl,-Bstatic"
mv ddd/ddd-2.2.3-${MACHINE}-pc-linux-gnulibc1 ddd/ddd-2.2.3-${MACHINE}-pc-linux-libc5-static
#
mv doc/README doc/README.doc
gzip -9 doc/ddd-paper.ps
gzip -9 doc/ddd.man-nopics.ps
gzip -9 doc/ddd.man.ps
gzip -9 ChangeLog

%install
install -s ddd/ddd-2.2.3-*-pc-linux-libc5-dynamic $RPM_BUILD_ROOT/usr/bin
install -s ddd/ddd-2.2.3-*-pc-linux-libc5-semistatic $RPM_BUILD_ROOT/usr/bin
install -s ddd/ddd-2.2.3-*-pc-linux-libc5-static $RPM_BUILD_ROOT/usr/bin
install -m 644 ddd/ddd.man $RPM_BUILD_ROOT/usr/man/man1/ddd.1
chown bin.bin $RPM_BUILD_ROOT/usr/bin/*
chown bin.bin $RPM_BUILD_ROOT/usr/man/*

# install docs by hand
cp -p $RPM_SOURCE_DIR/ddd-2.2.3-README.linux README.linux
cp -p ANNOUNCE BUGS COPYING COPYING.LIB ChangeLog.gz INSTALL NEWS PROBLEMS README TODO doc/README.doc doc/ddd-paper.ps.gz doc/ddd.man-nopics.ps.gz doc/ddd.man.ps.gz doc/sample.dddinit ddd/Ddd README.linux $RPM_BUILD_ROOT/usr/doc/ddd-2.2.3
chown -R bin.bin $RPM_BUILD_ROOT/usr/doc/*

%post dynamic
cd /usr/bin && ln -sf ddd-2.2.3-*-pc-linux-libc5-dynamic ddd

%post semistatic
cd /usr/bin && ln -sf ddd-2.2.3-*-pc-linux-libc5-semistatic ddd

%post static
cd /usr/bin && ln -sf ddd-2.2.3-*-pc-linux-gnu-static ddd

%postun dynamic
rm -f /usr/bin/ddd

%postun semistatic
rm -f /usr/bin/ddd

%postun static
rm -f /usr/bin/ddd


%clean
rm -rf $RPM_BUILD_ROOT

%files dynamic
/usr/bin/ddd-2.2.3-*-pc-linux-libc5-dynamic

%files semistatic
/usr/bin/ddd-2.2.3-*-pc-linux-libc5-semistatic

%files static
/usr/bin/ddd-2.2.3-*-pc-linux-libc5-static

%files doc
/usr/doc/ddd-2.2.3
/usr/man/man1/ddd.1
